## gammaray 2.3.0

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# Pass the following variables to cmake to control the build:
# (See Install.txt for more information)
#
# -DGAMMARAY_ENFORCE_QT4_BUILD=[true|false]
#  Force building against Qt4, even if Qt5 is found.
#  Default=false
#
# -DGAMMARAY_BUILD_UI=[true|false]
#  Build the client and in-process UI.
#  Default=true
#
# -DGAMMARAY_PROBE_ONLY_BUILD=[true|false]
#  Build only an additional probe configuration for an already existing launcher.
#  Default=false
#
# -DGAMMARAY_UNKNOWN_CXX_MANGLED_NAMES=[true|false]
#  Enable if your compiler uses an unsupported C++ name mangling scheme.
#  Default=false
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# Not available on Windows.
#
# To build the apidox, run 'make docs' after CMake (assumes doxygen is available)
#

project(GammaRay)

cmake_minimum_required(VERSION 2.8.12) # b/c of ECMGeneratePriFile.cmake
cmake_policy(SET CMP0020 NEW)
if(POLICY CMP0043)
  cmake_policy(SET CMP0043 NEW)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
set(CMAKE_MACOSX_RPATH TRUE)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

include(CheckCXXCompilerFlag)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(GammaRayMacros)
include(GammaRayMacrosInternal)
include(FeatureSummary)
include(ECMGeneratePriFile)

# Exit for blacklisted compilers (those that don't support C++11 very well)
#  MSVC++ 8.0  _MSC_VER == 1400 (Visual Studio 2005)
#  Clang 3.0
set(BAD_CXX_MESSAGE "")
if(MSVC)
  if(MSVC_VERSION LESS 1500)
    set(BAD_CXX_MESSAGE "MSVC 2008 or higher")
  endif()
endif()
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  if(${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 3.1.0)
    set(BAD_CXX_MESSAGE "Clang v3.1.0 or higher")
  endif()
endif()
if(BAD_CXX_MESSAGE)
  message(FATAL_ERROR "\nSorry, ${BAD_CXX_MESSAGE} is required to build this software. Please retry using a modern compiler that supports C++11 lambdas.")
endif()

# Enable the test harness
enable_testing()

# Version setup
set(GAMMARAY_VERSION_MAJOR "2")
set(GAMMARAY_VERSION_MINOR "3")
set(GAMMARAY_VERSION_PATCH "0")
set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
set(GAMMARAY_SOVERSION "2.3.0")
set(GAMMARAY_PLUGIN_VERSION "2.3")
set(PROJECT_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
if(ANDROID)
  # non-rooted Android doesn't like .so versions...
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES "")
else()
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES SOVERSION ${GAMMARAY_SOVERSION} VERSION ${GAMMARAY_SOVERSION})
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

message(STATUS "Building GammaRay ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")

#
# Build options
#
option(
  GAMMARAY_ENFORCE_QT4_BUILD
  "Enable if you want to enforce a build with Qt4"
  OFF
)

option(
  GAMMARAY_BUILD_UI
  "Build the GammaRay client and in-process UI."
  ON
)

option(
  GAMMARAY_PROBE_ONLY_BUILD
  "Build only an additional probe configuration for an already existing launcher."
  OFF
)

# TODO: find a nicer way for all this. ideally auto-detect the name mangling
# format, but at least guess a default based on OS + compiler.
option(
  GAMMARAY_UNKNOWN_CXX_MANGLED_NAMES
  "Enable if your compiler uses an unsupported C++ name mangling scheme"
  OFF
)

#
# Compiler & linker settings
#
if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GXX_UNUSED_BUT_SET)
  check_cxx_compiler_flag(-Wlogical-op HAVE_GXX_LOGICAL_OP)
  check_cxx_compiler_flag(-Wsizeof-pointer-memaccess HAVE_GXX_POINTER_MEMACCESS)
  check_cxx_compiler_flag(-Wreorder HAVE_GXX_REORDER)
  check_cxx_compiler_flag(-Wformat-security HAVE_GXX_FORMAT_SECURITY)
  check_cxx_compiler_flag(-std=gnu++0x HAVE_GXX_GNUXX11)
  check_cxx_compiler_flag(-std=c++0x HAVE_GXX_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Wmissing-noreturn -Werror=return-type")
  if(HAVE_GXX_GNUXX11) # QNX needs gnu++0x rather than c++0x for compiling QML V4 private headers
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
  elseif(HAVE_GXX_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
  if(HAVE_GXX_UNUSED_BUT_SET)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
  endif()
  if(HAVE_GXX_LOGICAL_OP)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
  endif()
  if(HAVE_GXX_POINTER_MEMACCESS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsizeof-pointer-memaccess")
  endif()
  if(HAVE_GXX_REORDER)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wreorder")
  endif()
  if(HAVE_GXX_FORMAT_SECURITY)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat -Wformat-security")
  endif()
  if(MINGW)
    # mingw will error out on the crazy casts in probe.cpp without this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
  else()
    # visibility attributes not supported on mingw, don't use -fvisibility option
    # see: http://stackoverflow.com/questions/7994415/mingw-fvisibility-hidden-does-not-seem-to-work
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
  endif()
endif()
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()
if("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Qunused-arguments")
endif()

if(WIN32)
  add_definitions(-DUNICODE -D_UNICODE)
endif()
if(QNXNTO)
  add_definitions(-D_QNX_SOURCE)
endif()

# linker flags
if(CMAKE_SYSTEM_NAME MATCHES Linux OR CMAKE_SYSTEM_NAME STREQUAL GNU)
  if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_SHARED_LINKER_FLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--fatal-warnings -Wl,--no-undefined -lc ${CMAKE_MODULE_LINKER_FLAGS}")
  endif()
endif()

#
# Finding Qt
#

# try Qt5 first, and prefer that (if found), but only if not disabled via option
if(NOT GAMMARAY_ENFORCE_QT4_BUILD)
  find_package(Qt5Core 5.1 QUIET)
else()
  set(Qt5Core_FOUND FALSE)
endif()

if(Qt5Core_FOUND)
  set_package_properties(Qt5Core PROPERTIES TYPE REQUIRED)
  find_package(Qt5 NO_MODULE REQUIRED COMPONENTS Gui Network)
  find_package(Qt5 NO_MODULE QUIET OPTIONAL_COMPONENTS
    Bluetooth
    Concurrent
    Designer
    PrintSupport
    Qml
    Quick
    Svg
    Script
    ScriptTools
    Test
    WebKitWidgets
    Widgets
  )
  if(GAMMARAY_BUILD_UI) # widgets are required for the UI
    find_package(Qt5 NO_MODULE REQUIRED COMPONENTS Widgets)
  endif()

  #HACK: CMake with broken Qt5Qml_PRIVATE_INCLUDE_DIRS, Qt5Quick_PRIVATE_INCLUDE_DIRS
  if(${Qt5Qml_FOUND})
    if(NOT "${Qt5Qml_PRIVATE_INCLUDE_DIRS}" MATCHES "/QtQml/")
      string(REPLACE "/QtCore" "/QtQml" replaceme "${Qt5Core_PRIVATE_INCLUDE_DIRS}")
      list(APPEND Qt5Qml_PRIVATE_INCLUDE_DIRS ${replaceme})
      list(REMOVE_DUPLICATES Qt5Qml_PRIVATE_INCLUDE_DIRS)
    endif()
  endif()
  if(${Qt5Quick_FOUND})
    if(NOT "${Qt5Quick_PRIVATE_INCLUDE_DIRS}" MATCHES "/QtQuick/")
      string(REPLACE "/QtCore" "/QtQuick" replaceme "${Qt5Core_PRIVATE_INCLUDE_DIRS}")
      list(APPEND Qt5Quick_PRIVATE_INCLUDE_DIRS ${Qt5Qml_PRIVATE_INCLUDE_DIRS})
      list(APPEND Qt5Quick_PRIVATE_INCLUDE_DIRS ${replaceme})
      list(REMOVE_DUPLICATES Qt5Quick_PRIVATE_INCLUDE_DIRS)
    endif()
  endif()

  include("cmake/ECMQt4To5Porting.cmake")

  set(HAVE_QT_CONCURRENT ${Qt5Concurrent_FOUND})
  set(HAVE_QT_WIDGETS ${Qt5Widgets_FOUND})
  set(HAVE_QT_SVG ${Qt5Svg_FOUND})
  set(HAVE_QT_DESIGNER ${Qt5Designer_FOUND})
  set(HAVE_QT_PRINTSUPPORT ${Qt5PrintSupport_FOUND})
  set(HAVE_QT_WEBKIT1 ${Qt5WebKitWidgets_FOUND})

  if(Qt5_POSITION_INDEPENDENT_CODE AND NOT WIN32)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  endif()

  # TODO: Remove me once fixed in ECM module
  # more hacks: find qpa/... includes
  # also see https://codereview.qt-project.org/#change,30483
  include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

  # TODO warnings rather than build errors for the deprecated methods would be nice...
  add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0)

  find_path(QT_PRIVATE_INCLUDE_DIR private/qobject_p.h PATHS ${Qt5Core_PRIVATE_INCLUDE_DIRS})
  if(QT_PRIVATE_INCLUDE_DIR)
    set(HAVE_PRIVATE_QT_HEADERS true)
  endif()

  find_path(_Qt5Quick_PRIVATE_INCLUDE_DIR private/qquickitem_p.h PATHS ${Qt5Quick_PRIVATE_INCLUDE_DIRS})
  if(_Qt5Quick_PRIVATE_INCLUDE_DIR)
    set(HAVE_PRIVATE_Qt5Quick_HEADERS true)
  endif()

  set_package_properties(Qt5 PROPERTIES URL "http://qt-project.org/")
  set_package_properties(Qt5Concurrent PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the GammaRay launcher process list.")
  set_package_properties(Qt5Widget PROPERTIES TYPE RECOMMENDED PURPOSE "Required for the GammaRay client UI and widget-related tools.")
  set_package_properties(Qt5Svg PROPERTIES TYPE OPTIONAL PURPOSE "Required for widget SVG export.")
  set_package_properties(Qt5PrintSupport PROPERTIES TYPE OPTIONAL PURPOSE "Required for widget PDF export.")
  add_feature_info("QPainter analyzer" HAVE_PRIVATE_QT_HEADERS "Requires private Qt headers to be available.")

# Qt4
else()
  set(QT_USE_IMPORTED_TARGETS true)
  find_package(Qt4 4.8.0 REQUIRED QtCore QtGui QtNetwork)
  find_package(Qt4 4.8.0 QUIET COMPONENTS QtScript QtScriptTools QtWebKit QtDesigner QtSvg QtTest)

  include(${QT_USE_FILE})
  set(HAVE_QT_CONCURRENT true)
  set(HAVE_QT_WIDGETS true)
  set(HAVE_QT_SVG true)
  if(QT_QTDESIGNER_FOUND)
    set(HAVE_QT_DESIGNER true)
  endif()
  set(HAVE_QT_PRINTSUPPORT true)
  set(HAVE_QT_WEBKIT1 ${QT_QTWEBKIT_FOUND})

  find_path(QT_PRIVATE_INCLUDE_DIR private/qobject_p.h PATHS ${QT_INCLUDES})
  if(QT_PRIVATE_INCLUDE_DIR)
    # not enough, some of them include harfbuzz headers, so we need to find those as well
    # for now we assume a regular Qt4 source build layout, but that probably should be generalized
    find_path(HARFBUZZ_INCLUDE_DIR harfbuzz.h PATH ${QT_PRIVATE_INCLUDE_DIR}/../../src/3rdparty/harfbuzz/src)
  endif()

  if(QT_PRIVATE_INCLUDE_DIR AND HARFBUZZ_INCLUDE_DIR)
    set(HAVE_PRIVATE_QT_HEADERS TRUE)
    include_directories(${HARFBUZZ_INCLUDE_DIR})
  else()
    set(HAVE_PRIVATE_QT_HEADERS FALSE)
    # needs to go before Qt includes, in case we have non-working headers with the same name there
    include_directories(BEFORE ${CMAKE_SOURCE_DIR}/3rdparty/qt/4.8)
  endif()

  set_package_properties(Qt4 PROPERTIES URL "http://qt-project.org/")
  add_feature_info("QPainter analyzer" HAVE_PRIVATE_QT_HEADERS
    "You must have a build version of Qt available. Make sure the qmake found first in your execute comes from this build version."
  )

  # C++11 compatibility with Qt5
  add_definitions(-DQ_DECL_OVERRIDE=)
endif()

add_definitions(-DQT_USE_FAST_CONCATENATION -DQT_USE_FAST_OPERATOR_PLUS)
# disable QT_STRICT_ITERATORS on the Qt5+Windows combo
# see: https://bugreports.qt-project.org/browse/QTBUG-29608

=== app/CMakeLists.txt ===
# Integrated launcher/client for Mac app bundles
if(APPLE)

set(gammaray_app_srcs main.cpp)

add_executable(gammaray-app MACOSX_BUNDLE ${gammaray_app_srcs})

target_link_libraries(gammaray-app
  ${QT_QTGUI_LIBRARIES}
  gammaray_common_internal
  gammaray_launcher_shared
  gammaray_launcher_ui_internal
  gammaray_client
)

set_target_properties(gammaray-app PROPERTIES
  OUTPUT_NAME "GammaRay"
  INSTALL_RPATH "@executable_path/../Frameworks"
  MACOSX_BUNDLE_INFO_STRING "GammaRay ${GAMMARAY_VERSION}"
  MACOSX_BUNDLE_ICON_FILE "GammaRay.icns"
  MACOSX_BUNDLE_GUI_IDENTIFIER "com.kdab.gammaray"
  MACOSX_BUNDLE_LONG_VERSION_STRING "${GAMMARAY_VERSION_STRING}"
  MACOSX_BUNDLE_BUNDLE_NAME "GammaRay"
  MACOSX_BUNDLE_SHORT_VERSION_STRING "${GAMMARAY_VERSION}"
  MACOSX_BUNDLE_BUNDLE_VERSION "${GAMMARAY_VERSION}"
  MACOSX_BUNDLE_COPYRIGHT "Copyright (C) 2010-2015 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com"
)

install(TARGETS gammaray-app ${INSTALL_TARGETS_DEFAULT_ARGS})

endif()

=== client/CMakeLists.txt ===
set(gammaray_clientlib_srcs
  client.cpp
  remotemodel.cpp
  selectionmodelclient.cpp
  clientconnectionmanager.cpp
  propertycontrollerclient.cpp
  probecontrollerclient.cpp
  clientdevice.cpp
  tcpclientdevice.cpp
  localclientdevice.cpp
)

qt4_add_resources(gammaray_clientlib_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)
add_library(gammaray_client SHARED ${gammaray_clientlib_srcs})
set_target_properties(gammaray_client PROPERTIES
  ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES}
  DEFINE_SYMBOL MAKE_GAMMARAY_CLIENT_LIB
)

target_link_libraries(gammaray_client
  LINK_PUBLIC
  ${QT_QTCORE_LIBRARIES}

  LINK_PRIVATE
  gammaray_ui
  gammaray_ui_internal
  gammaray_common
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTNETWORK_LIBRARIES}
)


set(gammaray_client_srcs main.cpp)

add_executable(gammaray-client WIN32 ${gammaray_client_srcs})

target_link_libraries(gammaray-client
  gammaray_client
  gammaray_common
  ${QT_QTGUI_LIBRARIES}
)

if(QNXNTO)
  target_link_libraries(gammaray-client cpp)
endif()

gammaray_embed_info_plist(gammaray-client ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
set_target_properties(gammaray-client PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${LIBEXEC_INSTALL_DIR}"
)

install(TARGETS gammaray_client EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS gammaray-client DESTINATION ${LIBEXEC_INSTALL_DIR})


gammaray_install_headers(
  gammaray_client_export.h
  clientconnectionmanager.h
)

ecm_generate_pri_file(BASE_NAME GammaRayClient
                      LIB_NAME gammaray_client
                      DEPS "core gui widgets network GammaRayCommon GammaRayUi"
                      FILENAME_VAR PRI_FILENAME
                      INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/..
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== common/CMakeLists.txt ===
#
# Shared non-UI code between probe and client
#
set(gammaray_common_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/klinkitemselectionmodel.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/kde/kmodelindexproxymapper.cpp
  ${CMAKE_SOURCE_DIR}/3rdparty/lz4/lz4.c

  methodargument.cpp
  objectbroker.cpp
  protocol.cpp
  message.cpp
  endpoint.cpp
  paths.cpp
  propertysyncer.cpp
)

add_library(gammaray_common SHARED ${gammaray_common_srcs})
set_target_properties(gammaray_common PROPERTIES
  ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES}
  DEFINE_SYMBOL MAKE_GAMMARAY_COMMON_LIB
  OUTPUT_NAME gammaray_common-${GAMMARAY_PROBE_ABI}
)

if(Qt5Core_FOUND)
  target_link_libraries(gammaray_common LINK_PUBLIC Qt5::Core LINK_PRIVATE Qt5::Network)
else()
  target_link_libraries(gammaray_common
    LINK_PUBLIC ${QT_QTCORE_LIBRARIES}
    LINK_PRIVATE ${QT_QTGUI_LIBRARIES} ${QT_QTNETWORK_LIBRARIES}
  )
endif()

install(TARGETS gammaray_common EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

set(gammaray_common_internal_srcs
  plugininfo.cpp
  pluginmanager.cpp
  proxyfactorybase.cpp
  propertycontrollerinterface.cpp
  probecontrollerinterface.cpp
  modelinspectorinterface.cpp
  resourcebrowserinterface.cpp
  networkselectionmodel.cpp
  streamoperators.cpp
  probeabi.cpp
  probeabidetector.cpp

  tools/objectinspector/propertiesextensioninterface.cpp
  tools/objectinspector/methodsextensioninterface.cpp
  tools/objectinspector/connectionsextensioninterface.cpp
)

if(WIN32)
  list(APPEND gammaray_common_internal_srcs probeabidetector_win.cpp)
elseif(APPLE)
  list(APPEND gammaray_common_internal_srcs probeabidetector_mac.cpp)
elseif(UNIX AND NOT QNXNTO)
  list(APPEND gammaray_common_internal_srcs probeabidetector_elf.cpp)
else()
  list(APPEND gammaray_common_internal_srcs probeabidetector_dummy.cpp)
endif()

add_library(gammaray_common_internal STATIC ${gammaray_common_internal_srcs})
set_target_properties(gammaray_common_internal PROPERTIES POSITION_INDEPENDENT_CODE ON)

target_link_libraries(gammaray_common_internal gammaray_common)
if(Qt5Core_FOUND)
  target_link_libraries(gammaray_common_internal Qt5::Gui Qt5::Network)
else()
  target_link_libraries(gammaray_common_internal
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTNETWORK_LIBRARIES}
  )
endif()

if(WIN32)
  target_link_libraries(gammaray_common_internal version)
endif()
if(APPLE)
  target_link_libraries(gammaray_common_internal "-framework CoreFoundation")
endif()

if (ANDROID)
    add_definitions(-DENABLE_MESSAGE_COMPRESSSION)
endif()

gammaray_install_headers(
  gammaray_common_export.h
  endpoint.h
  enums.h
  metatypedeclarations.h
  modelroles.h
  objectbroker.h
  objectmodel.h
  paths.h
  propertycontrollerinterface.h
  protocol.h
)

ecm_generate_pri_file(BASE_NAME GammaRayCommon
                      LIB_NAME gammaray_common-${GAMMARAY_PROBE_ABI}
                      DEPS "core gui network"
                      FILENAME_VAR PRI_FILENAME
                      INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/..
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== core/CMakeLists.txt ===
set(gammaray_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp

  aggregatedpropertymodel.cpp
  metaobject.cpp
  metaobjecttreemodel.cpp
  metaobjectrepository.cpp
  metaproperty.cpp
  metapropertymodel.cpp
  probe.cpp
  probeguard.cpp
  probesettings.cpp
  probecontroller.cpp
#  proxydetacher.cpp
  objectlistmodel.cpp
  objectpropertymodel.cpp
  objectdynamicpropertymodel.cpp
  objectstaticpropertymodel.cpp
  objectclassinfomodel.cpp
  objectmethodmodel.cpp
  objectenummodel.cpp
  objecttreemodel.cpp
  connectionmodel.cpp
  connectionfilterproxymodel.cpp
  methodargumentmodel.cpp
  multisignalmapper.cpp
  signalspycallbackset.cpp
  toolmodel.cpp
  toolpluginmodel.cpp
  toolpluginerrormodel.cpp
  propertycontroller.cpp
  propertycontrollerextension.cpp
  proxytoolfactory.cpp
  util.cpp
  varianthandler.cpp

  tools/modelinspector/modeltester.cpp
  tools/modelinspector/modelmodel.cpp
  tools/modelinspector/modelcellmodel.cpp
  tools/metatypebrowser/metatypesmodel.cpp
  tools/localeinspector/localemodel.cpp
  tools/localeinspector/localedataaccessor.cpp
  tools/localeinspector/localeaccessormodel.cpp
  tools/textdocumentinspector/textdocumentmodel.cpp
  tools/textdocumentinspector/textdocumentformatmodel.cpp
  tools/messagehandler/messagehandler.cpp
  tools/messagehandler/messagehandlerinterface.cpp
  tools/messagehandler/messagemodel.cpp
  tools/connectioninspector/connectioninspector.cpp
  tools/localeinspector/localeinspector.cpp
  tools/metaobjectbrowser/metaobjectbrowser.cpp
  tools/metatypebrowser/metatypebrowser.cpp
  tools/modelinspector/modelinspector.cpp
  tools/modelinspector/safetyfilterproxymodel.cpp
  tools/objectinspector/objectinspector.cpp
  tools/objectinspector/propertiesextension.cpp
  tools/objectinspector/methodsextension.cpp
  tools/objectinspector/connectionsextension.cpp
  tools/objectinspector/abstractconnectionsmodel.cpp
  tools/objectinspector/inboundconnectionsmodel.cpp
  tools/objectinspector/outboundconnectionsmodel.cpp
  tools/objectinspector/enumsextension.cpp
  tools/objectinspector/classinfoextension.cpp
  tools/resourcebrowser/resourcebrowser.cpp
  tools/resourcebrowser/resourcefiltermodel.cpp
  tools/textdocumentinspector/textdocumentinspector.cpp

  remote/server.cpp
  remote/remotemodelserver.cpp
  remote/selectionmodelserver.cpp
  remote/serverdevice.cpp
  remote/tcpserverdevice.cpp
  remote/localserverdevice.cpp
  remote/serverproxymodel.cpp
)

if(Qt5Core_FOUND)
  set(gammaray_srcs
    ${gammaray_srcs}
    tools/mimetypes/mimetypes.cpp
    tools/mimetypes/mimetypesmodel.cpp
    tools/standardpaths/standardpaths.cpp
    tools/standardpaths/standardpathsmodel.cpp
  )
endif()

if(NOT WIN32)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_unix.cpp)
elseif(MINGW)
  set(gammaray_srcs ${gammaray_srcs} tools/messagehandler/backtrace_dummy.cpp)
else()
  set(gammaray_srcs ${gammaray_srcs}
    tools/messagehandler/backtrace_win.cpp
    ${CMAKE_SOURCE_DIR}/3rdparty/StackWalker/StackWalker.cpp)
endif()

qt4_wrap_cpp(gammaray_srcs ${CMAKE_SOURCE_DIR}/3rdparty/qt/modeltest.h)
qt4_add_resources(gammaray_srcs ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc)

add_definitions(-DMAKE_GAMMARAY_CORE_LIB)

# core lib
add_library(gammaray_core SHARED
  ${gammaray_srcs}
)

target_link_libraries(gammaray_core
  LINK_PUBLIC gammaray_common
  LINK_PRIVATE gammaray_common_internal
)
set_target_properties(gammaray_core PROPERTIES
  ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES}
  OUTPUT_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
)

if(Qt5Core_FOUND)
  target_link_libraries(gammaray_core LINK_PUBLIC Qt5::Core LINK_PRIVATE Qt5::Gui)
else()
  target_link_libraries(gammaray_core
    LINK_PUBLIC ${QT_QTCORE_LIBRARIES} ${QT_QTGUI_LIBRARIES} # GUI is needed for QItemSelectionModel
    LINK_PRIVATE ${QT_QTNETWORK_LIBRARIES}
  )
endif()

install(TARGETS gammaray_core EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

gammaray_install_headers(
  gammaray_core_export.h
  metaobject.h
  metaobjectrepository.h
  metaproperty.h
  objectmodelbase.h
  objecttypefilterproxymodel.h
  probeinterface.h
  propertycontroller.h
  propertycontrollerextension.h
  signalspycallbackset.h
  singlecolumnobjectproxymodel.h
  toolfactory.h
  util.h
  varianthandler.h
)

ecm_generate_pri_file(BASE_NAME GammaRayCore
                      LIB_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
                      DEPS "core gui GammaRayCommon"
                      FILENAME_VAR PRI_FILENAME
                      INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/..
)

install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

=== docs/CMakeLists.txt ===
#
# man page
#
if(UNIX)
  find_program(POD2MAN_EXECUTABLE pod2man)
  gammaray_add_dummy_package(pod2man POD2MAN_EXECUTABLE)
  set_package_properties(pod2man PROPERTIES
    TYPE RECOMMENDED
    DESCRIPTION "Man page generator"
    PURPOSE "Generate GammaRay man pages."
  )

  if(POD2MAN_EXECUTABLE AND NOT GAMMARAY_PROBE_ONLY_BUILD)
    add_custom_command(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1
      COMMAND ${POD2MAN_EXECUTABLE} -c "KDAB Products" -r "\"${GAMMARAY_VERSION}\"" -s 1 ${CMAKE_CURRENT_SOURCE_DIR}/gammaray.pod ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gammaray.pod
    )
    add_custom_target(man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/gammaray.1 DESTINATION ${MAN_INSTALL_DIR})
  endif()
endif()

#
# API docs
#
find_package(Doxygen)
set_package_properties(Doxygen PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "API Documentation system"
  URL "http://www.doxygen.org"
  PURPOSE "Needed to build the API documention."
)
if(DOXYGEN_FOUND)
  file(GLOB _dox_deps *.dox *.html)
  gammaray_all_installed_headers(_all_hdrs)
  list(APPEND _all_hdrs ${_dox_deps})
  gammaray_join_list(DOXYGEN_INPUT " " ${_all_hdrs})

  #apidox generation using doxygen
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
  )

  add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/apidocs/html/index.html
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    DEPENDS ${_all_hdrs} ${_dox_deps} ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
  )
  add_custom_target(docs
    DEPENDS ${CMAKE_BINARY_DIR}/apidocs/html/index.html
  )

endif()

=== hooking/CMakeLists.txt ===
set(gammaray_probe_srcs
  probecreator.cpp
  hooks.cpp
)

if(UNIX AND Qt5Core_VERSION VERSION_LESS 5.4.0)
  list(APPEND gammaray_probe_srcs preload.cpp)
endif()

if(WIN32 OR APPLE)
  list(APPEND gammaray_probe_srcs
    abstractfunctionoverwriter.cpp
    functionoverwriterfactory.cpp
    unixfunctionoverwriter.cpp
  )
endif()

if(WIN32)
  list(APPEND gammaray_probe_srcs
    entry_win.cpp
    winfunctionoverwriter.cpp
  )
endif()

if(APPLE OR NOT Qt5Core_VERSION VERSION_LESS 5.4.0)
  list(APPEND gammaray_probe_srcs entry_unix.cpp)
endif()

# probe lib
if(APPLE) # DYLD_INSERT_LIBRARIES only works with real shared libraries, not modules
  add_library(gammaray_probe SHARED ${gammaray_probe_srcs})
  set_target_properties(gammaray_probe PROPERTIES INSTALL_RPATH "@loader_path/../../../Frameworks")
else()
  add_library(gammaray_probe MODULE ${gammaray_probe_srcs})
endif()
target_link_libraries(gammaray_probe
  gammaray_core
)

if(NOT WIN32 AND NOT QNXNTO AND NOT ANDROID)
  target_link_libraries(gammaray_probe dl)
endif()

if(NOT ANDROID)
  set_target_properties(gammaray_probe PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${PROBE_PLUGIN_INSTALL_DIR}"
  )
  set_target_properties(gammaray_probe PROPERTIES PREFIX "")
endif()

if(ANDROID)
  install(TARGETS gammaray_probe EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})
  ecm_generate_pri_file(BASE_NAME GammaRayProbe
                      LIB_NAME gammaray_probe
                      DEPS "core gui network GammaRayCommon GammaRayCore"
                      FILENAME_VAR PRI_FILENAME
                      INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/..)
  install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/gammaray_probe-android-dependencies.xml DESTINATION ${LIB_INSTALL_DIR})
else()
  install(TARGETS gammaray_probe DESTINATION ${PROBE_PLUGIN_INSTALL_DIR})
endif()

=== inprocessui/CMakeLists.txt ===
add_library(gammaray_inprocessui MODULE main.cpp)
target_link_libraries(gammaray_inprocessui gammaray_core gammaray_ui_internal)
set_target_properties(gammaray_inprocessui PROPERTIES
  PREFIX ""
  LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${PROBE_PLUGIN_INSTALL_DIR}"
)
install(TARGETS gammaray_inprocessui DESTINATION ${PROBE_PLUGIN_INSTALL_DIR})

=== launcher/CMakeLists.txt ===
add_subdirectory(injector)

if(NOT GAMMARAY_PROBE_ONLY_BUILD)
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
)

# shared launcher code
set(gammaray_launcher_shared_srcs
  injector/abstractinjector.cpp
  injector/processinjector.cpp
  injector/injectorfactory.cpp
  injector/styleinjector.cpp
  injector/windllinjector.cpp
  injector/interactiveprocess.cpp

  probefinder.cpp
  launchoptions.cpp
  clientlauncher.cpp
  launcherfinder.cpp
  launcher.cpp
)
if(NOT WIN32)
  list(APPEND gammaray_launcher_shared_srcs
    injector/debuggerinjector.cpp
    injector/gdbinjector.cpp
    injector/lldbinjector.cpp
    injector/preloadcheck.cpp
    injector/preloadinjector.cpp
  )
endif()
add_library(gammaray_launcher_shared STATIC ${gammaray_launcher_shared_srcs})
target_link_libraries(gammaray_launcher_shared ${QT_QTCORE_LIBRARIES} gammaray_common_internal)
if(HAVE_QT_WIDGETS)
  target_link_libraries(gammaray_launcher_shared ${QT_QTGUI_LIBRARIES})
endif()
if(UNIX AND NOT APPLE AND NOT QNXNTO)
  target_link_libraries(gammaray_launcher_shared dl) # for preload check
endif()

# command line launcher
set(gammaray_runner_srcs
  main.cpp
)

add_executable(gammaray ${gammaray_runner_srcs})

target_link_libraries(gammaray gammaray_launcher_shared)

if(QNXNTO)
  target_link_libraries(gammaray cpp)
endif()

gammaray_embed_info_plist(gammaray ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)

install(TARGETS gammaray ${INSTALL_TARGETS_DEFAULT_ARGS})

# UI launcher
if(HAVE_QT_CONCURRENT AND GAMMARAY_BUILD_UI)
  add_subdirectory(ui)
endif()
endif()

=== plugins/CMakeLists.txt ===
add_subdirectory(codecbrowser)
add_subdirectory(fontbrowser)
add_subdirectory(kjobtracker)
add_subdirectory(objectvisualizer)
add_subdirectory(quickinspector)
add_subdirectory(selectionmodelinspector)
add_subdirectory(signalmonitor)
add_subdirectory(statemachineviewer)
add_subdirectory(timertop)
add_subdirectory(webinspector)

if(Qt5Core_FOUND)
  add_subdirectory(translatorinspector)
endif()

if(Qt5Widgets_FOUND OR QT_QTGUI_FOUND)
  add_subdirectory(actioninspector)
  add_subdirectory(widgetinspector)
  add_subdirectory(sceneinspector)
  add_subdirectory(styleinspector)
endif()

if(QT_QTSCRIPTTOOLS_FOUND OR Qt5ScriptTools_FOUND)
  add_subdirectory(scriptenginedebugger)
endif()

if(Qt5Qml_FOUND)
  add_subdirectory(qmlsupport)
endif()

if(Qt5Bluetooth_FOUND)
  add_subdirectory(bluetooth)
endif()

=== resources/CMakeLists.txt ===
if(UNIX AND NOT APPLE AND GAMMARAY_BUILD_UI)
  install(
    FILES GammaRay-16x16.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/16x16/apps" RENAME GammaRay.png
  )
  install(
    FILES GammaRay-32x32.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/32x32/apps" RENAME GammaRay.png
  )
  install(
    FILES GammaRay-48x48.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/48x48/apps" RENAME GammaRay.png
  )
  install(
    FILES GammaRay-128x128.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/128x128/apps" RENAME GammaRay.png
  )
  install(
    FILES GammaRay-256x256.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/256x256/apps" RENAME GammaRay.png
  )
  install(
    FILES GammaRay-512x512.png
    DESTINATION "${ICON_INSTALL_DIR}/hicolor/512x512/apps" RENAME GammaRay.png
  )
endif()

if(APPLE)
  install(FILES GammaRay.icns DESTINATION "${RESOURCES_INSTALL_DIR}")
endif()

=== tests/CMakeLists.txt ===
### BENCH SUITE

if(Qt5Widgets_FOUND OR QT_QTGUI_FOUND)
  add_executable(benchsuite benchsuite.cpp)

  target_link_libraries(benchsuite
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTTEST_LIBRARIES}
    gammaray_common
    gammaray_core
  )

  if(QNXNTO)
    target_link_libraries(benchsuite cpp)
  endif()

### CONNECTIONTEST

  add_executable(connectiontest test_connections.cpp)

  target_link_libraries(connectiontest
    ${QT_QTCORE_LIBRARIES}
    ${QT_QTGUI_LIBRARIES}
    ${QT_QTTEST_LIBRARIES}
  )

  if(QNXNTO)
    target_link_libraries(connectiontest cpp)
  endif()
endif()

add_executable(attachhelper attachhelper.cpp)

target_link_libraries(attachhelper ${QT_QTCORE_LIBRARIES})

if(QNXNTO)
  target_link_libraries(attachhelper cpp)
endif()

if(UNIX)
  add_test(connectiontest-preload
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest -i preload
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )
  add_test(connectiontest-style
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest -i style
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )

  set(RUN_FILTER_TESTS OFF
    CACHE BOOL "Run filter tests which fail due to a bug in QSortFilterProxyModel"
  )
  if(RUN_FILTER_TESTS)
    add_test(connectiontest-preload-filter
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray -unittest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
    )
    add_test(connectiontest-preload-filter-modeltest
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray -unittest -modeltest -filtertest -i preload
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
    )
    add_test(connectiontest-style-filter
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray -unittest -filtertest -i style
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
    )
  endif()

  find_program(GDB_EXECUTABLE gdb)
  if(GDB_EXECUTABLE)
    add_test(connectiontest-gdb
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest -i gdb
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
    )
    add_test(attachtest-gdb
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/attachhelper ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray gdb
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
    )
    if(RUN_FILTER_TESTS)
      add_test(connectiontest-gdb-filter
        ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest -filtertest -i gdb
        ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
      )
    endif()
  endif()
endif()

### MultiSignalMapper test

add_executable(multisignalmappertest multisignalmappertest.cpp ../core/multisignalmapper.cpp)
target_link_libraries(multisignalmappertest
  ${QT_QTCORE_LIBRARIES}
  ${QT_QTGUI_LIBRARIES}
  ${QT_QTTEST_LIBRARIES}
)
add_test(multisignalmappertest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/multisignalmappertest)

### Probe ABI test

add_executable(probeabitest probeabitest.cpp)
target_link_libraries(probeabitest gammaray_common_internal ${QT_QTTEST_LIBRARIES})
add_test(probeabitest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/probeabitest)

add_executable(probeabidetectortest probeabidetectortest.cpp)
target_link_libraries(probeabidetectortest gammaray_common_internal ${QT_QTTEST_LIBRARIES})
add_test(probeabidetectortest ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/probeabidetectortest)

### Remote model tests

if(GAMMARAY_BUILD_UI AND NOT GAMMARAY_PROBE_ONLY_BUILD)
  add_executable(remotemodeltest
    remotemodeltest.cpp
    ${CMAKE_SOURCE_DIR}/3rdparty/qt/modeltest.cpp
    ../core/remote/remotemodelserver.cpp
  )
  target_link_libraries(remotemodeltest gammaray_core gammaray_client ${QT_QTGUI_LIBRARIES} ${QT_QTTEST_LIBRARIES} ${QT_QTNETWORK_LIBRARIES})
  add_test(NAME remotemodeltest COMMAND remotemodeltest)
endif()

### QSignalSpyCallback tests

add_executable(signalspycallbacktest
  signalspycallbacktest.cpp
  ../hooking/probecreator.cpp
)
target_link_libraries(signalspycallbacktest gammaray_core ${QT_QTTEST_LIBRARIES})
add_test(NAME signalspycallbacktest COMMAND signalspycallbacktest)

### QAction test

if(Qt5Core_FOUND AND NOT Qt5Core_VERSION_MINOR LESS 4) # requires QHooks
add_executable(actiontest
  actiontest.cpp
  ../hooking/probecreator.cpp
  ../hooking/hooks.cpp
)
target_link_libraries(actiontest gammaray_core ${QT_QTTEST_LIBRARIES} ${QT_QTGUI_LIBRARIES})

add_test(NAME actiontest COMMAND actiontest)
endif()

### MetaObject test

add_executable(metaobjecttest metaobjecttest.cpp)
target_link_libraries(metaobjecttest gammaray_core ${QT_QTTEST_LIBRARIES})
add_test(NAME metaobjecttest COMMAND metaobjecttest)

### PropertySyncer test

add_executable(propertysyncertest propertysyncertest.cpp)
target_link_libraries(propertysyncertest gammaray_common ${QT_QTGUI_LIBRARIES} ${QT_QTTEST_LIBRARIES})
add_test(NAME propertysyncertest COMMAND propertysyncertest)

### PropertyBinder test

if(GAMMARAY_BUILD_UI)
add_executable(propertybindertest propertybindertest.cpp)
target_link_libraries(propertybindertest gammaray_ui ${QT_QTTEST_LIBRARIES})
add_test(NAME propertybindertest COMMAND propertybindertest)
endif()


add_subdirectory(manual)

=== debian/changelog ===
gammaray (2.3.0-3build1) xenial; urgency=medium

  * New upstream version, Ubuntu specific changes can be dropped.
  * No-change rebuild against Qt 5.5.1.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 30 Nov 2015 14:44:18 +0000

gammaray (2.3.0-3) unstable; urgency=medium

  * Disable attachtest-gdb on s390x. It's unstable and hangs builds.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 29 Aug 2015 00:45:11 +0200

gammaray (2.3.0-2) unstable; urgency=medium

  * Build-depend on libvtk6-qt-dev only on architectures where it's actually
    available.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 27 Aug 2015 17:21:49 +0200

gammaray (2.3.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Refresh use-empty-rpath.patch.
  * Build-depend on the new libvtk6-qt-dev package. (Closes: #793604)
  * Explicitly disable VTK for the Qt4 build. It throws errors but isn't
    actually used.
  * Add "Enhances: gammaray" to the plugins. (Closes: #791353)

 -- Felix Geyer <fgeyer@debian.org>  Thu, 27 Aug 2015 12:53:08 +0200

gammaray (2.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh debian-archs-fix-build.patch and fix-objectvisualizer-build.patch.
  * Install new signalmonitor and translatorinspector plugins.
  * Update d/changelog with (re)moved files.
  * Re-enable objectvisualizer plugin since Qt5-compatible VTK has become
    available.
  * Don't set RPATH in binaries; prevents binary-or-shlib-defines-rpath
    lintian error.
  * Disable build of Qt4 web inspector plugin since qtwebkit is to be removed
    from the repository (Closes: #784466).
  * Remove patches included upstream:
    - gldouble.patch
    - qsglayer.patch.

 -- Jakub Adam <jakub.adam@ktknet.cz>  Thu, 02 Jul 2015 20:42:51 +0200

gammaray (2.1.0-5) unstable; urgency=medium

  * Apply changes from 2.1.0-3.1ubuntu2 by Dmitry Shachnev:
    - Backport one more upstream patch, to fix build on armhf.
    - Adapt to Qt 5.4 API changes (LP: #1395646).

 -- Felix Geyer <fgeyer@debian.org>  Thu, 25 Jun 2015 19:32:55 +0200

gammaray (2.1.0-4) unstable; urgency=medium

  [ Felix Geyer ]
  * Fix FTBFS on ppc64el (Closes: #765672).
  * Let xvfb-run choose a free server number so it doesn't fail when one is
    already taken.
  * Update watch file.

  [ Jakub Adam ]
  * Drop build dependency on libqt4-private-dev (Closes: #763852)
    - gammaray is the last package still using it and has the needed Qt4 private
      headers already bundled with the source code. Dropping the dependency will
      allow libqt4-private-dev to be removed from Debian.
  * Bump Standards-Version to 3.9.6.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 26 May 2015 16:59:03 +0200

gammaray (2.1.0-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix FTBFS on mips64(el), as on mips* platform, they use the same
    e_machine value (Closes: #761805).

 -- YunQiang Su <syq@debian.org>  Thu, 09 Oct 2014 13:24:02 +0800

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: debhelper (>= 9),
               cmake,
               kdelibs5-dev,
               qtbase5-private-dev,
               qtscript5-dev,
               qttools5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               qtdeclarative5-private-dev,
               libqt4-dev,
               libgraphviz-dev,
               libvtk6-qt-dev [!armel !armhf],
               gdb,
               xauth,
               xvfb
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/gammaray.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-extras/gammaray.git
Homepage: http://www.kdab.com/gammaray

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: gammaray-probe-qt4,
            gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-probe-qt4
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: gammaray (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: GammaRay support for inspecting Qt4 applications
 This package contains GammaRay probe libraries that have to be loaded
 into the application being inspected in order to allow GammaRay to
 examine its internals. The gammaray package already includes the probe
 binaries compiled for Qt5. Install this package if you want to use
 GammaRay with Qt4 applications.

Package: gammaray-plugin-objectvisualizer
Architecture: any
Depends: gammaray (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: QObject hierarchy visualization plugin for GammaRay
 This plugin can visualize parent-child relationships of QObjects in a
 form of planar or 3D acyclic graph. Multiple graph layout algorihtms
 are available.
 .
 Also, for use with 3D glasses, various types of stereoscopic rendering
 are supported.

Package: gammaray-plugin-quickinspector
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml-module-qtquick2,
         qml-module-qtquick-controls,
         ${shlibs:Depends},
         ${misc:Depends}
Enhances: gammaray
Description: GammaRay plugin for inspecting QtQuick2 applications
 This plugin provides the user with the following inspection and debugging
 facilities:
 .
  * Tree view of all QQuickItems in the scene, marking invisible items
    and items having focus.
  * Object inspector allowing to see all the properties, inspect
    signal-slot connections, and directly invoke slots and Q_INVOKABLE
    methods.
  * Live-preview of the QtQuick scene inside the GammaRay window.
  * Qt Quick scene graph inspector.

Package: gammaray-plugin-kjobtracker
Architecture: any
Depends: gammaray (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Enhances: gammaray
Description: KJob tracker plugin for GammaRay
 This plugin can be used to monitor KJob instances within a KDE-based
 application.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}),
         gammaray-probe-qt4 (= ${binary:Version}),
         ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

Package: gammaray-dbg
Architecture: any
Section: debug
Priority: extra
Depends: gammaray (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for gammaray
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains the debugging symbols for gammaray.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install override_dh_installdocs override_dh_strip

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -B obj-qt5
	dh_auto_configure -B obj-qt4 -- -DGAMMARAY_ENFORCE_QT4_BUILD=ON -DGAMMARAY_PROBE_ONLY_BUILD=ON -DCMAKE_DISABLE_FIND_PACKAGE_VTK=True

override_dh_auto_build:
	dh_auto_build -B obj-qt5 -O--parallel
	dh_auto_build -B obj-qt4 -O--parallel

override_dh_auto_test:
# tests fail on kfreebsd because of bug #570805: Wrong path in /proc/pid/maps when bind mounted
ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386))
	xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -B obj-qt5 || true
# attachtest-gdb is unstable on s90x and hangs builds
else ifeq ($(DEB_HOST_ARCH), s390x)
	xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -B obj-qt5 -- ARGS="-E attachtest-gdb"
else
	xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -B obj-qt5
endif

override_dh_auto_install:
	dh_auto_install -B obj-qt5
	dh_auto_install -B obj-qt4
	rm -f debian/tmp/usr/share/doc/gammaray/License.txt

override_dh_auto_clean:
	dh_auto_clean -B obj-qt5
	dh_auto_clean -B obj-qt4

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray

override_dh_strip:
	dh_strip --dbg-package=gammaray-dbg
